﻿$(document).ready(function () {
    reIndex();
    setPositions();
    InitDropDown();
});

function Swap(from, to) {
    
    if (to == 0) {
        alert(Localization_CantSwapTop);
        return;
    }
    else if (to == $("table.table-generic tr").length)
    {
        alert(Localization_CantSwapBot);
        return;
    }

    $.ajax({
        url: RQ_URL + "/CustomFields/Swap",
        data: {
            from: from,
            to: to
        },
        context: document.body,
        cache: false,
        async: true,
        success: function (data) {

            var offset = 1; // +1 protoze nth-child bere i hlavicku tabulky a o tu se musime posunout

            // clone element1 and put the clone before element2
            var from_element = $('table.table-generic tr.no-border:eq(' + (from - 1) + ')');
            var to_element = $('table.table-generic tr.no-border:eq(' + (to - 1) + ')');

            // replace the original element1 with element2
            // leaving the element1 clone in it's place
            if (from > to)
                to_element.before(from_element);
            else
                to_element.after(from_element);

            reIndex();
        },
        error: function (xhr, textStatus, thrownError) { }
    });
}

function reIndex()
{
    $("table.table-generic tr.no-border").each(function (index) {

        // jquery indexuje od 0, pozice prvku se indexuje od 1. Upravime pozici pro cislovani podle prvku
        var pos = index + 1;

        $("img:nth-child(1)", $(this)).attr("onclick", "javascript:Swap(" + pos + "," + (pos - 1) + ")");
        $("img:nth-child(2)", $(this)).attr("onclick", "javascript:Swap(" + pos + "," + (pos + 1) + ")");
    });
}

/*******************************************************************************************************************/
/*                              DROP DOWN TEMPLATE                                                                 */
/*******************************************************************************************************************/
function AddItem() {
    
    var ctn = $(".dropdown-item").length;
    var max = 0;

    $('div.dropdown-item tr.dropdown-item-tag input.input-text').each(function () {
        var number = Number($(this).val());
        if (number > max) { max = number; }
    });

    var nextTagValue = max + 1;

    var html = '<div class="dropdown-item">' +
    '<table>' +
        '<tr>' +
            '<td>' + Localization_Title + '</td>' +
            '<td><input id="items_' + ctn + '__Title" name="items[' + ctn + '].Title" type="text" size="26" class="input-text radius" /></td>' +
            '<td style="width:80px;">' +
            '<img class="hand" src="' + RQ_URL + '/Content/img/icon-up.png" alt="' + Localization_MoveUp + '" title="' + Localization_MoveUp + '" />' +
            '<img class="hand" src="' + RQ_URL + '/Content/img/icon-down.png" alt="' + Localization_MoveDown + '" title="' + Localization_MoveDown + '" />' +
            '<img class="hand" src="' + RQ_URL + '/Content/img/icon-cross.png" alt="' + Localization_Delete + '" title="' + Localization_Delete + '" onclick="javascript:RemoveItem(' + ctn + ');" />' +
            '<div class="clear"></div>' +
            '<input id="items_' + ctn + '__ID" name="items[' + ctn + '].ID" type="hidden" value="0" />' +
            '<input id="items_' + ctn + '__Order" name="items[' + ctn + '].Order" type="hidden" value="' + ctn + '" />' +
            '</td>' +
        '</tr>' +
        '<tr class="dropdown-item-tag">' +
            '<td>' + Localization_Tag + '</td>' +
            '<td colspan="2"><input id="items_' + ctn + '__Tag" name="items[' + ctn + '].Tag" type="text" size="26" class="input-text radius" value="' + nextTagValue + '" /></td>' +
        '</tr>' +
    '</table>' +
    '</div>';

    $("#dropdown-item-end").before(html);

    setPositions();
}

function RemoveItem(position) {
 
    $(".dropdown-item").each(function (index) {
        if (index == position)
            $(this).remove();
    });

    setPositions();
}

function setPositions() {

    $(".dropdown-item").each(function (index) {

        var id_dest = $('input[type="hidden"]:first', $(this)).attr("id").substring(6); // odseknuti items_

        var pos = id_dest.indexOf("_", 0);
        id_dest = id_dest.substring(0, pos);
        
        $('input', $(this)).each(function () {

            var name = $(this).attr("name");
            name = name.replace(id_dest, index);
            $(this).attr("name", name);

            var id = $(this).attr("id");
            id = id.replace(id_dest, index);
            $(this).attr("id", id);

            if ($(this).attr("id").indexOf("Order") != -1) {
                $(this).val(index + 1);
            }

        });

        var pos = index + 1; //poradi se dela od 1
        // schovani sipek
        if (index == 0) $("img:nth-child(1)", $(this)).hide();
        else $("img:nth-child(1)", $(this)).show();

        if (index == ($(".dropdown-item").length - 1)) $("img:nth-child(2)", $(this)).hide();
        else $("img:nth-child(2)", $(this)).show();

        $("img:nth-child(1)", $(this)).attr("onclick", "javascript:SwapItem(" + pos + "," + (pos - 1) + ")");
        $("img:nth-child(2)", $(this)).attr("onclick", "javascript:SwapItem(" + pos + "," + (pos + 1) + ")");
        $("img:nth-child(3)", $(this)).attr("onclick", "javascript:RemoveItem(" + index + ")");
    });
}

function SwapItem(from, to) {

    if (to == 0) {
        alert(Localization_CantSwapTop);
        return;
    }
    else if (to == ($(".dropdown-item").length + 1)) {
        alert(Localization_CantSwapBot);
        return;
    }

    //var offset = 1;

    var from_element = $('div.dropdown-item:eq(' + (from - 1) + ')');
    var to_element = $('div.dropdown-item:eq(' + (to - 1) + ')');
    // replace the original element1 with element2
    // leaving the element1 clone in it's place

    if (from > to)
        to_element.before(from_element);
    else
        to_element.after(from_element);
        
    setPositions();
}

function InitDropDown() {
    
    $("#AddPleaseSelectItem").change(function () {
        SetRequiredDisplay();
    });

    SetRequiredDisplay();
}

function SetRequiredDisplay() {

    if ($("#AddPleaseSelectItem").is(":checked")) {

        $("#OperatorRequired").removeAttr("disabled");
        $("#EndUserRequired").removeAttr("disabled");
    }
    else {
        $("#OperatorRequired").attr("disabled", "disabled");
        $("#EndUserRequired").attr("disabled", "disabled");
    }
}

function Sort() {

    var count = $('.dropdown-item').length - 1;
    $('.dropdown-item').each(function () {
        $('.dropdown-item').each(function (index) {
            if (index != count) {
                var a = $(".dropdown-item:eq(" + index + ") #items_" + index + "__Title");
                var b = $(".dropdown-item:eq(" + (index + 1) + ") #items_" + (index + 1) + "__Title");

                if (a.val() > b.val()) {
                    SwapItem((index + 1), (index + 2));
                }

            }
        });
    });
}