﻿
$(document).ready(function () {   

    $("#tbSubject").focus();

    $("#dialogAddNewCustomer").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Create,
                click: function () {
                    $("#addNewCustomerForm").submit();
                }
            },
            {
                text: Localization_Cancel,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });

    $('#ddlEmailToAddress').change(function () {
        $('#lbEmailToAddressError').hide();
    });

    $('#ddlMailBoxes').change(function () {
        $('#lbMailBoxesError').hide();
    });

    $('#btSubmitUp').click(function () {
        $('#formNewTicket').submit();
    });

    $("#formNewTicket").submit(function () {
        if (dontShowMessage) {
            window.tinyMCE.get('tbMessage').setContent(lastServerMessage);
        }

        //aby se nevyhodnocovalo zkracene a zobrazily se vsechny error hlasky        
        var isFormValid = $(this).valid();
        var isMessageValid = ValidateMessage();
        var isCreationAndStartSolvingDatesValid = ValidateCreationAndStartSolvingDates();
        var isEmailSubmitModeValid = ValidateEmailSubmitMode();
        var isServiceValid = ValidateService();
        var areCategoriesValid = ValidateCategories();
        var isInventoryValid = ValidateInventory();

        if (isEmailSubmitModeValid && isFormValid && isMessageValid && isCreationAndStartSolvingDatesValid && isServiceValid && areCategoriesValid && isInventoryValid) {
            $("#btSubmitUp").prop("disabled", true);
            $("#tbSubject").prop('disabled', false);
            $('#pickfiles').css({ visibility: "hidden" });
            $('#hiddenMessage').val(window.tinyMCE.get('tbMessage').getContent());
            OnAjaxBegin(Localization_SendingPleaseWait);

            if (uploader.files.length > 0) {
                $('div[id^="divFile"] a').hide(); //schova [Remove]
                if (!filesUploaded) {
                    uploader.start();
                    return false; //submitnu az po odeslani souboru
                }
            }
        }
        else {
            $('#CloseImmediately').val('False');
            return false; //zrusit odeslani validace pokud neprojde explicitni validace
        }
    });

    $('#aEmailToAddressesCopy').click(function () {
        $('#trEmailToAddressesCopy').show();
        $(this).hide();
    });

    $('#aEmailToAddressesBlindCopy').click(function () {
        $('#trEmailToAddressesBlindCopy').show();
        $(this).hide();
    });

    $('#btEmailToAddressesCopyClear').click(function () {
        $('#ddlEmailToAddressesCC').val('').trigger('change')
        $('#trEmailToAddressesCopy').hide();
        $('#aEmailToAddressesCopy').show();
    });

    $('#btEmailToAddressesBlindCopyClear').click(function () {
        $('#ddlEmailToAddressesBCC').val('').trigger('change')
        $('#trEmailToAddressesBlindCopy').hide();
        $('#aEmailToAddressesBlindCopy').show();
    });

    initCategories();
});


function LoadAllRelatedToService() {
    LoadSolvers(); //related to Service
    LoadCustomForms(); //related to Service
    LoadInventory(); //related to Service
    LoadPriorities(); //related to Service
    LoadDeadline(); //related to Service
    LoadCreationTime(); //related to Service
    LoadCategories(); //related to Service
    //LoadStartSolvingTime(); //related to Service  -je v LoadCreationTime kvuli poradi zobrazeni
}

function ValidateMessage() {
    $('#spanMessageRequired').hide();

    var isMessageValid = window.tinyMCE.get('tbMessage').getContent().length > 0;

    if (!isMessageValid) {
        $('#spanMessageRequired').show();
        return false;
    }

    return true;
}

function formatSize(bytes) {
    if (bytes < 10 * 1024)
        return bytes + "&nbsp;B";
    else if (bytes < 10 * 1024 * 1024)
        return Math.round(bytes / 1024) + "&nbsp;kB";
    else
        return Math.round(bytes / 1024 / 1024) + "&nbsp;MB";
}

function GetPassword()
{   
    $.ajax({
        type: "get",
        url: RQ_URL + "/Account/GeneratePassword",
        dataType: "text",
        success: function (result) {
            $('#UserPassword').val(result);
        }
    });
}

function LoadCustomer(id) {
    $("#Customers").load(RQ_URL + "/Tickets/CustomerPartial");
}

function AddCustomerResult(result) {
    if (result.success) { // je to definováné jen když se to vrátí jako JSON
        CloseAddCustomerDialog();
    } else {
        $('#dialogFormAddNewCustomer').html(result);
    }
}

function AddCustomer() {
    $("#dialogFormAddNewCustomer").html("<div class='loading-32'></div>");
    $("#dialogAddNewCustomer").dialog("open");
    $("#dialogFormAddNewCustomer").load(RQ_URL + "/Customers/NewCustomerDialog", function () {
        SearchableCombos();
        $("#dialogAddNewCustomer").dialog("close");
        $("#dialogAddNewCustomer").dialog("open");
    });
}

function CloseAddCustomerDialog() {
    $("#dialogAddNewCustomer").dialog("close");
    LoadCustomer("#Customers");
}

function AddUser() {   
    //$("#errorTextUser").parent().parent().css("display", "none");
    $("#dialogAddNewUser").html("<div class='loading-32'></div>");

    $("#dialogAddNewUser").dialog({
        autoOpen: true,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
    });

    $("#dialogAddNewUser").load(RQ_URL + "/Account/RegisterUserDialogPartial", function () {
        Select2Combos();
        $("#dialogAddNewUser").dialog("close");

        $("#dialogAddNewUser").dialog({
            autoOpen: true,
            resizable: false,
            width: 850,
            height: "auto",
            modal: true,
            buttons: [
                {
                    text: Localization_Create,
                    click: function () {
                        $('#formRegisterUser').submit();
                    }
                },
                {
                    text: Localization_Cancel,
                    click: function () {
                        $(this).dialog("close");
                    }
                }
            ]
        });
    });
}

function OnRegisterUserSuccess(result) {
    if (result.success) {
        $("#dialogAddNewUser").dialog("close");

        if (result.html != null) { //if UseFullRegistration is false, this is null, no another page
            $("#dialogAddNewUserComplete").html(result.html); //continue to next form
            $("#dialogAddNewUserComplete").dialog({
                autoOpen: true,
                resizable: false,
                width: 550,
                height: "auto",
                modal: true,
                buttons: [
                    {
                        text: Localization_Close,
                        click: function () {
                            $(this).dialog("close");

                            //set new user as submitter
                            var option = $('<option/>');
                            option.attr({ 'value': result.user.id, 'title': result.user.text }).text(formatSubmitter(result.user));
                            $('#ddlSubmitter').append(option);
                            $('#ddlSubmitter').val(result.user.id).trigger('change');
                        }
                    }
                ]
            });
        }
        else {
            //set new user as submitter
            var option = $('<option/>');
            option.attr({ 'value': result.user.id, 'title': result.user.text }).text(formatSubmitter(result.user));
            $('#ddlSubmitter').append(option);
            $('#ddlSubmitter').val(result.user.id).trigger('change');
        }
    }
    else {
        $('#dialogAddNewUser').html(result); //some form errors, redisplay form
    }
}

/*function SetAttributeBoxesSameHeight() {
    $(".attribute-boxes > section.block").css("min-height", function () {
        return 130; //default min height
    });

    var maxHeight = Math.max.apply(null, $(".attribute-boxes > section.block").map(function () {
        return $(this).height();
    }).get());

    $(".attribute-boxes > section.block").css("min-height", function () {
        return maxHeight + 1;
    });
}*/

var knowledgebaseSuggestionsShown = false;
var articlesIds = new Array();

function GetAutocompleteKB() {

    var divArticles = $("#knowledgebase-suggestions-articles");

    var q = $("#tbSubject").val();
    if (q.length > 2) {
        var position = $("#tbSubject").offset();

        $.post(
        RQ_URL + '/KnowledgeBase/SearchForArticlesAutocomplete',
        { searchText: q },
        function (data) {
            var articlesIds2 = new Array();
            var i = 0;

            $(data).each(function () {
                articlesIds2[i++] = this.Id;
            });

            //$('#test').html("0[" + articlesIds + "]<br/>2[" + articlesIds2 + "]");

            if (!($(articlesIds).not(articlesIds2).length == 0 && $(articlesIds2).not(articlesIds).length == 0)) {
                articlesIds = articlesIds2;
                divArticles.empty();

                if ($(data).length != 0) {
                    //$("#autocompleteKB_ul li.ticketMessage-autocomplete").remove();

                    $(data).each(function () {
                        if (this.Title === "showmore") {
                            /*var li = $(document.createElement('li')).attr("class", "main");
                            var a_link = $(document.createElement('a')).attr("href", "javascript:void(0);").text("Zobrazit více (" + this.Url + ")");
    
                            a_link.click(function () {
                                $('#formKnowledgeBaseSearchFor').submit();
                            });
    
                            a_link.appendTo(li);
                            li.appendTo($("#divAutocompleteKB"));*/
                        }
                        else {
                            var divArticle = $(document.createElement('div')).attr("class", "knowledgebase-suggestions-article");
                            var img = $(document.createElement('img')).attr("src", this.CategoryImgSrc).attr("alt", this.CategoryName).attr("title", this.CategoryName).appendTo(divArticle);
                            var divArticleText = $(document.createElement('div')).attr("class", "knowledgebase-suggestions-article-text").appendTo(divArticle);
                            var h1 = $(document.createElement('h1')).appendTo(divArticleText);
                            var a = $(document.createElement('a')).attr("href", this.Url).attr("target", "_blank").text(this.Title).appendTo(h1);
                            var divIntro = $(document.createElement('div')).text(this.Introduction).appendTo(divArticleText);
                            divArticle.appendTo(divArticles);
                            divArticle.fadeIn();
                        }
                    });
                }
            }
        },
        "json"
        )
        .fail(function (error) { alert(error.responseText); })
        .done(function () {
            if ($("div.knowledgebase-suggestions-article").length > 0) {
                $('#knowledgebase-no-articles-found').hide();
                $('#knowledgebase-articles-found').show();

                if (!knowledgebaseSuggestionsShown) {
                    $('#knowledgebase-suggestions').fadeIn();
                    knowledgebaseSuggestionsShown = true;
                }
            }
            else {
                $('#knowledgebase-articles-found').hide();
                $('#knowledgebase-no-articles-found').show();
            }
        });
    }
    else {
        divArticles.empty();
        articlesIds = new Array();
        $('#knowledgebase-articles-found').hide();
        $('#knowledgebase-no-articles-found').show();
    }


}

function ValidateCreationAndStartSolvingDates() {
    $('#errorStartSolving').hide();

    if ($('#new-ticket-start-solving').length == 1) {
        var createdDateStr = '';
        var createdTimeStr = '';

        if ($('#new-ticket-created').length == 1) {
            createdDateStr = $('#tbCreatedDate').val().trim();
            createdTimeStr = $('#tbCreatedTime').val().trim();
        }

        var startSolvingDateStr = $('#tbStartSolvingDate').val().trim();
        var startSolvingTimeStr = $('#tbStartSolvingTime').val().trim();

        if (createdDateStr == '' && createdTimeStr != '') {
            createdDateStr = moment().format("L");
            $('#tbCreatedDate').val(createdDateStr);
        }

        if (startSolvingDateStr == '' && startSolvingTimeStr != '') {
            startSolvingDateStr = moment().format("L");
            $('#tbStartSolvingDate').val(startSolvingDateStr);
        }

        if (startSolvingDateStr != '') {
            var startSolving = moment($('#tbStartSolvingDate').val() + ' ' + $('#tbStartSolvingTime').val(), "L LT");

            var created = createdDateStr != '' ? moment($('#tbCreatedDate').val() + ' ' + $('#tbCreatedTime').val(), "L LT") : moment();

            if (created > startSolving) {
                $('#errorStartSolving').show();
                return false;
            }
        }
    }

    return true;
}

function ValidateEmailSubmitMode() {
    $('#lbMailBoxesError').hide();
    $('#lbEmailToAddressError').hide();
    var error = false;

    if ($('#hiddenSubmitMode').val() == 'Email') {

        if ($('#ddlMailBoxes').val() == '') {
            $('#lbMailBoxesError').show();
            error = true;
        }

        if (!isValidEmailAddress($('#ddlEmailToAddress').val())) {
            $('#lbEmailToAddressError').show();
            error = true;
        }
    }

    return !error;
}

function ValidateService() {
    var ddlServices = $('#ddlServices');
    $('#lbServiceError').hide();

    if (ddlServices.length == 1 && ddlServices.closest('tr').is(':visible')) {

        if (ddlServices.val() == null || ddlServices.val() == '') { //null je kdyz je vybrany zadavatel (nacene sluzby), jinak je tam '' kdyz tam je jen prazdny option
            $('#lbServiceError').show();
            return false;
        }

    }

    return true;
}

function ValidateCategories() {
    var categories = $('select.select2TreeCategories');
    var isValid = true;
    $('.category-validation').hide();
    if (categories.length != 0) {

        $.each(categories, function (index, value) {
            if ($(value).data("selectionrequired") == "True" && $(value).val() == "") {
                isValid = false;
                $(value).closest("tr").find(".category-validation").show();
            }
        });
    }

    return isValid;
}

function ValidateInventory() {
    $('#lbInventoryError').hide();
    var required = $('#hiddenInventoryIsRequired').val() == 'True';

    if (required) {
        var divItems = $('#configuration-items-list');

        if (divItems.find('.configuration-item').length == 0) {
            $('#lbInventoryError').show();
            return false;
        }
    }

    return true;
}

function GetPredefinedReplyHtml(tiny, replyId) {
    OnAjaxBegin();
    $.get(
        RQ_URL + "/Tickets/GetPredefinedReplyHtml",
        {
            id: replyId,
        },
        function (data) {
            tiny.execCommand('mceInsertContent', false, data);
        },
        "html"
    )
        .done(function () {
            OnAjaxComplete();
        });
}

function initCategories() {
    $("select.select2TreeCategories").select2tree({
        width: '500px',
        placeholder: Localization_TicketIsNotPlacedInTheCategory
    });

    $(".select2TreeCategories").change(function () {
        LoadCustomForms();
    });
}