﻿$(document).ready(function () {

    $("#formPriority").submit(function () {
        if ($('#formPriority').validate().checkForm() && ValidatePriorityMatrix()) {
            $("#dialog-priority-conditions").prependTo("#beforesubmit");
        }
    });

    $('#rbSimplePriority').change(function () {
        if ($(this).is(':checked')) {
            //alert('simple');
            $('#tabs a[href="#tab-priorities"]').tab('show') // Select tab by name
            $('#tabs a[href="#tab-urgencies"]').parent().hide();
            $('#tabs a[href="#tab-impacts"]').parent().hide();
            $('#tabs a[href="#tab-priority-matrix"]').parent().hide();
        }
    });

    $('#rbPriorityMatrix').change(function () {
        if ($(this).is(':checked')) {
            $('#tabs a[href="#tab-urgencies"]').parent().show();
            $('#tabs a[href="#tab-impacts"]').parent().show();
            $('#tabs a[href="#tab-priority-matrix"]').parent().show();
        }
    });

    /* ---------------------- Priority Tabs --------------------------------------------------------------- */

    $('ul#tabs a').click(function (e) {
        e.preventDefault();
        $(this).tab('show')
    })

    $('#tabs li.hidden').hide();

    /* ---------------------- Priority Conditions document ready ------------------------------------------ */

    $("#dialog-priority-conditions").dialog({
        autoOpen: false,
        modal: true,
        resizable: true,
        width: 'auto',
        height: 'auto',
        buttons: [
            {
                text: Localization_Ok,
                click: function () {
                    var inputs = $('#dialog-priority-conditions-content :input');
                    var priorityConditionsModel = inputs.serializeArray();

                    $.post(
                        RQ_URL + "/Priority/PriorityConditionsAndGetReadableHtml",
                        priorityConditionsModel,
                        function (html) {
                            $("#divPriorityCondition").html(html);
                        },
                        "json"
                        )
                        .fail(function (error) { alert(error.responseText); });

                    $(this).dialog("close");
                }
            },
            {
                text: Localization_Cancel,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });

    $('#divPriorityCondition').click(function () {
        $("#dialog-priority-conditions").dialog('open');
    });


    /* ---------------------- Priority Values document ready ---------------------------------------------- */

    InitSortablePriorityValueRows();

    $('#btAddPriorityValue').click(function () {
        AddPriorityValue();
    });

    $(".colorSelector-input").each(function () {
        InitColorPicker($(this));
    });

    $('#tableBodyOfPriorityValues').on('click', 'a.pv-row-edit', function () {
        var tr = $(this).closest('tr');
        EditPriorityValue(tr);
    });

    $('#tableBodyOfPriorityValues').on('click', 'a.pv-row-cancel-edit', function () {
        var tr = $(this).closest('tr');
        CancelEditPriorityValue(tr);
    });

    $('#tableBodyOfPriorityValues').on('click', 'a.pv-row-save', function () {
        var tr = $(this).closest('tr');
        SavePriorityValue(tr);
    });

    $('#tableBodyOfPriorityValues').on('click', 'a.pv-row-delete', function () {
        var tr = $(this).closest('tr');
        DeletePriorityValueConfirm(tr);
    });

    $("#dialog-confirm-priority-value-delete").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
    });

    /* ---------------------- Priority Urgencies document ready ------------------------------------------- */

    InitSortablePriorityUrgencyRows();

    $('#btAddPriorityUrgency').click(function () {
        AddPriorityUrgency();
    });

    $('#tableBodyOfPriorityUrgencies').on('click', 'a.pu-row-edit', function () {
        var tr = $(this).closest('tr');
        EditPriorityUrgency(tr);
    });

    $('#tableBodyOfPriorityUrgencies').on('click', 'a.pu-row-cancel-edit', function () {
        var tr = $(this).closest('tr');
        CancelEditPriorityUrgency(tr);
    });

    $('#tableBodyOfPriorityUrgencies').on('click', 'a.pu-row-save', function () {
        var tr = $(this).closest('tr');
        SavePriorityUrgency(tr);
    });

    $('#tableBodyOfPriorityUrgencies').on('click', 'a.pu-row-delete', function () {
        var tr = $(this).closest('tr');
        DeletePriorityUrgencyConfirm(tr);
    });

    $("#dialog-confirm-priority-urgency-delete").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
    });

    /* ---------------------- Priority Values document ready ---------------------------------------------- */

    InitSortablePriorityImpactRows();

    $('#btAddPriorityImpact').click(function () {
        AddPriorityImpact();
    });

    $('#tableBodyOfPriorityImpacts').on('click', 'a.pi-row-edit', function () {
        var tr = $(this).closest('tr');
        EditPriorityImpact(tr);
    });

    $('#tableBodyOfPriorityImpacts').on('click', 'a.pi-row-cancel-edit', function () {
        var tr = $(this).closest('tr');
        CancelEditPriorityImpact(tr);
    });

    $('#tableBodyOfPriorityImpacts').on('click', 'a.pi-row-save', function () {
        var tr = $(this).closest('tr');
        SavePriorityImpact(tr);
    });

    $('#tableBodyOfPriorityImpacts').on('click', 'a.pi-row-delete', function () {
        var tr = $(this).closest('tr');
        DeletePriorityImpactConfirm(tr);
    });

    $("#dialog-confirm-priority-impact-delete").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
    });

    /* ---------------------- Priority Matrix document ready ---------------------------------------------- */

    $('#tablePriorityMatrix').on('click', 'td.value', function (e) {
        var show = !$(this).find('div.editable').is(':visible');        

        $('#tablePriorityMatrix td.value div.editable').hide();
        $('#tablePriorityMatrix td.value div.readonly').show();

        if (show) {
            $(this).find('div.editable select').val($(this).find('.hiddenPriorityValueIndex').val());

            $(this).find('div.readonly').hide();
            $(this).find('div.editable').show();

        }
    });

    $('#tablePriorityMatrix').on('change', 'td.value div.editable select', function (e) {
        var td = $(this).closest('td.value');

        td.find('.hiddenPriorityValueIndex').val($(this).val());
        td.find('div.readonly').text($(this).find('option:selected').text());
        td.css('background-color', $(this).find('option:selected').data('color'));

        td.find('div.editable').hide();
        td.find('div.readonly').show();
    });

    $('#tablePriorityMatrix').on('click', 'td.value div.editable select', function (e) {
        e.stopPropagation();
    });
});


/* ---------------------- Priority Conditions functions ----------------------------------------------- */

function AddItem(type) {

    var options = "";
    var options2 = "";

    $.ajax({
        url: RQ_URL + "/Priority/GetConditionsFieldValues",
        context: document.body,
        async: false
    }).done(function (data) {
        $(data).each(function () {
            options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
        });
    });

    $.ajax({
        url: RQ_URL + "/Priority/GetConditionsEnumeratorOrDataType?RuleId=1",
        context: document.body,
        async: false
    }).done(function (data) {
        $(data).each(function () {
            options2 += "<option value='" + this.Value + "'>" + this.Text + "</option>";
        });
    });

    var pos = $("tr." + type + "-row").length;
    var row = '<tr class="' + type + '-row">' +
                '<td><select id="Conditions_' + type + '_' + pos + '__FilterColumn" name="Conditions.' + type + '[' + pos + '].FilterColumn" onchange="RuleFieldChanged(' + pos + ',\'' + type + '\')">' + options + '</select></td>' +
                '<td>' +
                    '<select id="Conditions_' + type + '_' + pos + '__FilterOperator" name="Conditions.' + type + '[' + pos + '].FilterOperator"><option value="1">' + Localization_Is + '</option><option value="2">' + Localization_IsNot + '</option></select> ' +
                    '<select id="Conditions_' + type + '_' + pos + '__FilterStringValue" name="Conditions.' + type + '[' + pos + '].FilterStringValue">' + options2 + '</select>' +
                '</td>' +
                '<td><img class="hand" src="' + RQ_URL + '/Content/img/icon-cross.png" alt="' + Localization_Delete + '" title="' + Localization_Delete + '" onclick="javascript:RemoveRow(' + pos + ',\'' + type + '\')"/></td>' +
              '</tr>';

    $("tr.add-item-" + type).before(row);
}

function RuleFieldChanged(row, type) {

    var options = "";
    var id = $("#Conditions_" + type + "_" + row + "__FilterColumn").val();

    $.ajax({
        url: RQ_URL + "/Priority/GetConditionsOperatorValues?RuleId=" + id,
        context: document.body,
        async: false
    }).done(function (data) {
        $("#" + type + "_" + row + "__FilterOperator option").remove();
        $(data).each(function () {
            options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
        });
        $("#" + type + "_" + row + "__FilterOperator").html(options);
    });

    options = "";

    $.ajax({
        url: RQ_URL + "/Priority/GetConditionsEnumeratorOrDataType?RuleId=" + id,
        context: document.body,
        async: false
    }).done(function (data) {

        $("#Conditions_" + type + "_" + row + "__FilterStringValue").remove();
        var operator_ddl = $("#Conditions_" + type + "_" + row + "__FilterOperator");

        if (data == "spinner") {
            operator_ddl.after('<input type="text" value="1" class="spinner" id="Conditions_' + type + '_' + row + '__FilterStringValue" name="Conditions.' + type + '[' + row + '].FilterStringValue" />');
            InitSpinnersAndDatePickers();
        }
        else {
            operator_ddl.after(' <select id="Conditions_' + type + '_' + row + '__FilterStringValue" name="Conditions.' + type + '[' + row + '].FilterStringValue"></select>');
            $(data).each(function () {
                options += "<option value='" + this.Value + "'>" + htmlEncode(this.Text) + "</option>";
            });
            $("#Conditions_" + type + "_" + row + "__FilterStringValue").html(options);
        }
    });
}

function InitSpinnersAndDatePickers() {
    $('.spinner').spinner({ min: 1, max: 999 });
    $(".datepicker").datepicker();
}

function RemoveRow(row, type) {

    $("tr." + type + "-row:eq(" + row + ")").remove();
    ReIndex(type);
}

function ReIndex(type) {

    $("tr." + type + "-row").each(function (index) {

        $("img", this).attr("onclick", "javascript:RemoveRow(" + index + ",'" + type + "')");

        $("select, input", this).each(function () {

            var select = $(this);
            var id = select.attr("id");
            var pos = id.lastIndexOf("_");
            if (pos != -1) {
                id = id.substring(pos + 1);
                select.attr("id", "" + type + "_" + index + "__" + id);
                select.attr("name", "" + type + "[" + index + "]." + id);

                if (select.attr("onchange"))
                    select.attr("onchange", "RuleFieldChanged(" + index + ",'" + type + "')");
            }
            else
                alert("Reindex failed");
        });
    });
}


/* ---------------------- Priority Values functions --------------------------------------------------- */

function InitSortablePriorityValueRows() {
    $("#tableBodyOfPriorityValues").sortable({
        handle: ".handle",
        axis: "y",
        update: function (event, ui) {
            PriorityValueInputNamesRefresh();
        },
        start: function (event, ui) {
            ui.item.startPos = ui.item.index();
        },
        stop: function (event, ui) {
            //update to priority matrix
            PriorityMatrixMove(ui.item.startPos, ui.item.index(), "SwapPriorityValueOptions");
            PriorityMatrixModelRefresh();
        }
    });
}

function SwapPriorityValueOptions(i, j) {
    $('#tablePriorityMatrix td.value').each(function () {
        var select = $(this).find('div.editable select');

        var source_option_text = select.find('option').eq(i + 1).text();
        var source_option_color = select.find('option').eq(i + 1).data('color');
        var source_option_selected = select.find('option').eq(i + 1).prop('selected');

        var target_option_text = select.find('option').eq(j + 1).text();
        var target_option_color = select.find('option').eq(j + 1).data('color');
        var target_option_selected = select.find('option').eq(j + 1).prop('selected');

        var option_source = select.find('option').eq(i + 1);
        option_source.text(target_option_text);
        option_source.data('color', target_option_color);
        option_source.prop('selected', target_option_selected);

        var option_target = select.find('option').eq(j + 1);
        option_target.text(source_option_text);
        option_target.data('color', source_option_color);
        option_target.prop('selected', source_option_selected);

        var hiddenPriorityValueIndex = $(this).find('.hiddenPriorityValueIndex');

        if (source_option_selected && i == hiddenPriorityValueIndex.val()) {
            hiddenPriorityValueIndex.val(j);
        }
        else if (target_option_selected && j == hiddenPriorityValueIndex.val()) {
            hiddenPriorityValueIndex.val(i);
        }
    });
}

function AddPriorityValue()
{
    $('#spanPriorityValueNameRequired').hide();

    var priorityValueName = $('#tbPriorityValueName').val();
    var priorityValueDescription = $('#tbPriorityValueDescription').val();
    var priorityValueColor = $('#tbPriorityValueColor').val();
    var error = false;

    if (priorityValueName.trim() == '') {
        $('#spanPriorityValueNameRequired').show();
        error = true;
    }

    if (priorityValueColor.trim() == '' || !CheckColor(priorityValueColor)) {
        $('#spanPriorityValueColorError').show();        
    }

    if (!error) {
        $('#trPriorityValueNoValues').hide();

        $('<tr class="priority-value">' +
            '<td><div class="handle"></div><input class="priorityValueId" type="hidden"></td>' +
            '<td>' +
            '   <div class="readonly tbPriorityValueName">' + htmlEncode(priorityValueName) + '</div>' +
            '   <div class="editable hidden">' +
            '       <input type="text" class="required tbPriorityValueName" value="' + htmlEncode(priorityValueName) + '" />' +
            '       <input class="tbPriorityValueName" value="' + htmlEncode(priorityValueName) + '" type="hidden">' +
            '       <div class="valid-error hidden spanPriorityValueNameRequired">Zadejte prosím název.</div>' +
            '   </div>' +
            '</td>' +
            '<td>' +
            '   <div class="readonly tbPriorityValueDescription">' + htmlEncode(priorityValueDescription) + '</div>' +
            '   <div class="editable hidden">' +
            '       <input type="text" class="tbPriorityValueDescription" value="' + htmlEncode(priorityValueDescription) + '" />' +
            '       <input class="tbPriorityValueDescription" value="' + htmlEncode(priorityValueDescription) + '" type="hidden">' +
            '   </div>' +
            '</td>' +
            '<td>' +
            '   <div class="readonly tbPriorityValueColor" style="background-color: ' + priorityValueColor + '">' + priorityValueColor + '</div>' +
            '   <div class="editable hidden">' +
            '       <input type="text" class="required tbPriorityValueColor input-text radius colorSelector-input" maxlength="32" value="' + priorityValueColor + '" />' +
            '       <div class="colorSelector colorSelectortbPriorityValueColor"><div></div></div>' +
            '       <input class="tbPriorityValueColor" value="' + priorityValueColor + '" type="hidden">' +
            '       <div id="spanPriorityValueColorError" class="valid-error hidden spanPriorityValueColorError">Zadejte prosím barvu.</div>' +
            '   </div>' +
            '</td>' +
            '<td class="center nowrap">' +
            '   <div class="readonly">' +
            '       <div class="actions">' +
            '           <a href="javascript:void(0);" class="pv-row-edit">' + Localization_Edit + '</a>' +
            '           <a href="javascript:void(0);" class="pv-row-delete">' + Localization_Delete + '</a>' +
            '       </div>' +
            '   </div>' +
            '   <div class="editable hidden">' +
            '       <div class="actions">' +
            '           <a href="javascript:void(0);" class="button-blue small pv-row-save">' + Localization_Save + '</a>' +
            '           <a href="javascript:void(0);" class="pv-row-cancel-edit">' + Localization_Cancel + '</a>' +
            '       </div>' +
            '   </div>' +
            '</td> ' +           
        '</tr>').prependTo($('#tableBodyOfPriorityValues'));

        $('#tbPriorityValueName').val('');
        $('#tbPriorityValueDescription').val('');
        //$('#tbPriorityValueColor').val('');
        //ColorChanged($('#tbPriorityValueColor'));

        PriorityValueInputNamesRefresh();

        //update to priority matrix
        //dam na konec a posunu dopredu
        var lastIndex = $('#tableBodyOfPriorityValues tr.priority-value').length - 1;
        $('#tablePriorityMatrix td.value div.editable select').each(function () {
            $('<option />').text(priorityValueName).val(lastIndex).data('color', priorityValueColor).appendTo($(this));
        });

        PriorityMatrixMove(lastIndex, 0, "SwapPriorityValueOptions");
    }
}

function EditPriorityValue(tr) {
    $('#tableBodyOfPriorityValues tr.priority-value div.editable').hide();
    $('#tableBodyOfPriorityValues tr.priority-value div.readonly').show();

    tr.find('div.editable input[type="text"].tbPriorityValueName').val(tr.find('div.editable input[type="hidden"].tbPriorityValueName').val());
    tr.find('div.editable input[type="text"].tbPriorityValueDescription').val(tr.find('div.editable input[type="hidden"].tbPriorityValueDescription').val());
    tr.find('div.editable input[type="text"].tbPriorityValueColor').val(tr.find('div.editable input[type="hidden"].tbPriorityValueColor').val());
    ColorChanged(tr.find('div.editable input[type="text"].tbPriorityValueColor'));

    tr.find('div.readonly').hide();
    tr.find('div.editable').show();
}

function CancelEditPriorityValue(tr) {
    tr.find('div.editable').hide();
    tr.find('div.readonly').show();
}

function SavePriorityValue(tr) {
    tr.find('div.editable .spanPriorityValueNameRequired').hide();
    tr.find('div.editable .spanPriorityValueColorError').hide();

    var priorityValueName = tr.find('div.editable input[type="text"].tbPriorityValueName').val();
    var priorityValueDescription = tr.find('div.editable input[type="text"].tbPriorityValueDescription').val();
    var priorityValueColor = tr.find('div.editable input[type="text"].tbPriorityValueColor').val();
    var error = false;

    if (priorityValueName.trim() == '') {
        tr.find('div.editable .spanPriorityValueNameRequired').show();
        error = true;
    }

    if (priorityValueColor.trim() == '' || !CheckColor(priorityValueColor)) {
        tr.find('div.editable .spanPriorityValueColorError').show();
        error = true;
    }

    if (!error) {
        tr.find('div.editable input[type="hidden"].tbPriorityValueName').val(priorityValueName);
        tr.find('div.editable input[type="hidden"].tbPriorityValueDescription').val(priorityValueDescription);
        tr.find('div.editable input[type="hidden"].tbPriorityValueColor').val(priorityValueColor);

        tr.find('div.readonly.tbPriorityValueName').text(priorityValueName);
        tr.find('div.readonly.tbPriorityValueDescription').text(priorityValueDescription);
        tr.find('div.readonly.tbPriorityValueColor').text(priorityValueColor);
        tr.find('div.readonly.tbPriorityValueColor').css('background-color', priorityValueColor);

        //update to priority matrix
        var trIndex = tr.prevAll().length;
        $('#tablePriorityMatrix td.value div.editable select option[value="' + trIndex + '"]').text(priorityValueName);
        $('#tablePriorityMatrix td.value div.editable select option:selected[value="' + trIndex + '"]').closest('td.value').find('div.readonly').text(priorityValueName);
        $('#tablePriorityMatrix td.value div.editable select option:selected[value="' + trIndex + '"]').closest('td.value').css('background-color', priorityValueColor);

        tr.find('div.editable').hide();
        tr.find('div.readonly').show();
    }
}

function DeletePriorityValueConfirm(tr) {
    if ($('#tableBodyOfPriorityImpacts tr.impact-value').length == 1) {
        alert("Alespoň jedna položka musí zůstat.");
    }
    else {
        $("#dialog-confirm-priority-value-delete").dialog({
            buttons: [
                {
                    text: Localization_Yes,
                    click: function () {
                        //update to priority matrix
                        //odsunu mazanou prioritu na konec a smazu
                        var trIndex = tr.prevAll().length;
                        var lastIndex = $('#tableBodyOfPriorityValues tr.priority-value').length - 1;
                        PriorityMatrixMove(trIndex, lastIndex, "SwapPriorityValueOptions");
                        var selectedOptions = $('#tablePriorityMatrix td.value div.editable select option:selected[value="' + lastIndex + '"]');
                        var td = selectedOptions.closest('td.value');
                        td.find('.hiddenPriorityValueIndex').val("-1");
                        td.find('div.readonly').text("-- Vyberte --");
                        td.css("background-color", "white");
                        $('#tablePriorityMatrix td.value div.editable select option[value="' + lastIndex + '"]').remove();

                        //remove priority value
                        tr.remove();

                        if ($('#tableBodyOfPriorityValues tr.priority-value').length == 0) {
                            $('#trPriorityValueNoValues').show();
                        }

                        $(this).dialog("close");
                        PriorityValueInputNamesRefresh();

                    }
                },
                {
                    text: Localization_No,
                    click: function () {
                        $(this).dialog("close");
                    }
                }
            ]
        });

        $("#dialog-confirm-priority-value-delete").dialog("open");
    }
}

function PriorityValueInputNamesRefresh()
{
    var index = 0;

    $('#tableBodyOfPriorityValues tr.priority-value').each(function () {
        var priorityValueId = $(this).find('input[type="hidden"].priorityValueId');
        var tbPriorityValueName = $(this).find('div.editable input[type="hidden"].tbPriorityValueName');
        var tbPriorityValueDescription = $(this).find('div.editable input[type="hidden"].tbPriorityValueDescription');
        var tbPriorityValueColor = $(this).find('div.editable input[type="hidden"].tbPriorityValueColor');
        
        priorityValueId.attr('name', 'PriorityValues[' + index + '].Id')
        tbPriorityValueName.attr('name', 'PriorityValues[' + index + '].Name')
        tbPriorityValueDescription.attr('name', 'PriorityValues[' + index + '].Description')
        tbPriorityValueColor.attr('name', 'PriorityValues[' + index + '].Color')

        index++;
    });
}

/* ---------------------- Priority Urgencies functions --------------------------------------------------- */

function InitSortablePriorityUrgencyRows() {
    $("#tableBodyOfPriorityUrgencies").sortable({
        handle: ".handle",
        axis: "y",
        update: function (event, ui) {
            PriorityUrgencyInputNamesRefresh();
        },
        start: function (event, ui) {
            ui.item.startPos = ui.item.index();
        },
        stop: function (event, ui) {
            //update to priority matrix
            //reorder urgency columns
            PriorityMatrixMove(ui.item.startPos, ui.item.index(), "SwapPriorityUrgencyColumns");
            PriorityMatrixModelRefresh();
        }
    });
}

function PriorityMatrixMove(a, b, swap_func) {
    if (a < b) {
        for (var i = a; i < b; i++) {
            window[swap_func](i, i + 1);
        }
    }
    else if (a > b) {
        for (var i = a; i > b; i--) {
            window[swap_func](i - 1, i);
        }
    }
}

function SwapPriorityUrgencyColumns(i, j) {
    var cols = $('#tablePriorityMatrix tr td.urgency-label.name');
    var temp = cols.eq(i).html();
    cols.eq(i).html(cols.eq(j).html());
    cols.eq(j).html(temp);

    //switch urgency column values
    $('#tablePriorityMatrix tr.priority-matrix-row').each(function () {
        var cols = $(this).find('td.value');
        cols.eq(i).swapWith(cols.eq(j));
    });
}

jQuery.fn.swapWith = function (to) {
    return this.each(function () {
        var copy_to = $(to).clone(true);
        var copy_from = $(this).clone(true);
        $(to).replaceWith(copy_from);
        $(this).replaceWith(copy_to);
    });
};

function swapNodes(a, b) {
    var aparent = a.parentNode;
    var asibling = a.nextSibling === b ? a : a.nextSibling;
    b.parentNode.insertBefore(a, b);
    aparent.insertBefore(b, asibling);
}

function AddPriorityUrgency() {
    $('#spanPriorityUrgencyNameRequired').hide();

    var priorityUrgencyName = $('#tbPriorityUrgencyName').val();
    var priorityUrgencyDescription = $('#tbPriorityUrgencyDescription').val();
    var error = false;

    if (priorityUrgencyName.trim() == '') {
        $('#spanPriorityUrgencyNameRequired').show();
        error = true;
    }

    if (!error) {
        $('#trPriorityUrgencyNoValues').hide();

        $('<tr class="urgency-value">' +
            '<td><div class="handle"></div><input class="priorityUrgencyId" type="hidden"></td>' +
            '<td>' +
            '   <div class="readonly tbPriorityUrgencyName">' + htmlEncode(priorityUrgencyName) + '</div>' +
            '   <div class="editable hidden">' +
            '       <input type="text" class="required tbPriorityUrgencyName" value="' + htmlEncode(priorityUrgencyName) + '" />' +
            '       <input class="tbPriorityUrgencyName" value="' + htmlEncode(priorityUrgencyName) + '" type="hidden">' +
            '       <div class="valid-error hidden spanPriorityUrgencyNameRequired">Zadejte prosím název.</div>' +
            '   </div>' +
            '</td>' +
            '<td>' +
            '   <div class="readonly tbPriorityUrgencyDescription">' + htmlEncode(priorityUrgencyDescription) + '</div>' +
            '   <div class="editable hidden">' +
            '       <input type="text" class="tbPriorityUrgencyDescription" value="' + htmlEncode(priorityUrgencyDescription) + '" />' +
            '       <input class="tbPriorityUrgencyDescription" value="' + htmlEncode(priorityUrgencyDescription) + '" type="hidden">' +
            '   </div>' +
            '</td>' +
            '<td class="center nowrap">' +
            '   <div class="readonly">' +
            '       <div class="actions">' +
            '           <a href="javascript:void(0);" class="pu-row-edit">' + Localization_Edit + '</a>' +
            '           <a href="javascript:void(0);" class="pu-row-delete">' + Localization_Delete + '</a>' +
            '       </div>' +
            '   </div>' +
            '   <div class="editable hidden">' +
            '       <div class="actions">' +
            '           <a href="javascript:void(0);" class="button-blue small pu-row-save">' + Localization_Save + '</a>' +
            '           <a href="javascript:void(0);" class="pu-row-cancel-edit">' + Localization_Cancel + '</a>' +
            '       </div>' +
            '   </div>' +
            '</td> ' +
        '</tr>').prependTo($('#tableBodyOfPriorityUrgencies'));

        $('#tbPriorityUrgencyName').val('');
        $('#tbPriorityUrgencyDescription').val('');

        PriorityUrgencyInputNamesRefresh();

        //update to priority matrix
        $('<td></td>').attr({ class: 'urgency-label name' }).text(priorityUrgencyName).insertAfter($('#tablePriorityMatrix tr').eq(1).find('td').eq(1));

        $('#tablePriorityMatrix tr.priority-matrix-row td.impact-label.name').each(function () {
            CreateNewTdValueCell().insertAfter($(this));
        });

        $('#tablePriorityMatrix td.ax-label.urgency-label').attr('colspan', $('#tablePriorityMatrix tr td.urgency-label.name').length);

        PriorityMatrixModelRefresh();
    }
}

function CreateNewTdValueCell() {
    var td = $('<td></td>').attr({ class: 'value', style: 'background-color: white;' });
    $('<input />').attr({ type: 'hidden', class: 'hiddenPriorityUrgencyIndex' }).appendTo(td);
    $('<input />').attr({ type: 'hidden', class: 'hiddenPriorityImpactIndex' }).appendTo(td);
    $('<input />').attr({ type: 'hidden', class: 'hiddenPriorityValueIndex' }).val('-1').appendTo(td);
    $('<div></div>').attr({ class: 'readonly' }).text('-- Vyberte --').appendTo(td);
    var divEditable = $('<div></div>').attr({ class: 'editable hidden' }).appendTo(td);
    var select = $('<select></select>').appendTo(divEditable);
    $('<option />').val('-1').text('-- Vyberte --').data('color', 'white').appendTo(select);
    var i = 0;

    $("#tableBodyOfPriorityValues tr.priority-value").each(function () {
        var tbPriorityValueName = $(this).find('div.editable input[type="hidden"].tbPriorityValueName');
        var tbPriorityValueColor = $(this).find('div.editable input[type="hidden"].tbPriorityValueColor');

        $('<option />').val(i).text(tbPriorityValueName.val()).data('color', tbPriorityValueColor.val()).appendTo(select);
        i++;
    });

    return td;
}

function EditPriorityUrgency(tr) {
    $('#tableBodyOfPriorityUrgencies tr.urgency-value div.editable').hide();
    $('#tableBodyOfPriorityUrgencies tr.urgency-value div.readonly').show();

    tr.find('div.editable input[type="text"].tbPriorityUrgencyName').val(tr.find('div.editable input[type="hidden"].tbPriorityUrgencyName').val());
    tr.find('div.editable input[type="text"].tbPriorityUrgencyDescription').val(tr.find('div.editable input[type="hidden"].tbPriorityUrgencyDescription').val());

    tr.find('div.readonly').hide();
    tr.find('div.editable').show();
}

function CancelEditPriorityUrgency(tr) {
    tr.find('div.editable').hide();
    tr.find('div.readonly').show();
}

function SavePriorityUrgency(tr) {
    tr.find('div.editable .spanPriorityUrgencyNameRequired').hide();
    tr.find('div.editable .spanPriorityUrgencyColorError').hide();

    var priorityUrgencyName = tr.find('div.editable input[type="text"].tbPriorityUrgencyName').val();
    var priorityUrgencyDescription = tr.find('div.editable input[type="text"].tbPriorityUrgencyDescription').val();
    var error = false;

    if (priorityUrgencyName.trim() == '') {
        tr.find('div.editable .spanPriorityUrgencyNameRequired').show();
        error = true;
    }

    if (!error) {
        tr.find('div.editable input[type="hidden"].tbPriorityUrgencyName').val(priorityUrgencyName);
        tr.find('div.editable input[type="hidden"].tbPriorityUrgencyDescription').val(priorityUrgencyDescription);

        tr.find('div.readonly.tbPriorityUrgencyName').text(priorityUrgencyName);
        tr.find('div.readonly.tbPriorityUrgencyDescription').text(priorityUrgencyDescription);

        //update to priority matrix
        var trIndex = tr.prevAll().length;
        $('#tablePriorityMatrix td.urgency-label.name').eq(trIndex).text(priorityUrgencyName);

        tr.find('div.editable').hide();
        tr.find('div.readonly').show();
    }
}

function DeletePriorityUrgencyConfirm(tr) {
    if ($('#tableBodyOfPriorityImpacts tr.impact-value').length == 1) {
        alert("Alespoň jedna položka musí zůstat.");
    }
    else {
        $("#dialog-confirm-priority-urgency-delete").dialog({
            buttons: [
                {
                    text: Localization_Yes,
                    click: function () {
                        //update to priority matrix
                        var trIndex = tr.prevAll().length;
                        $('#tablePriorityMatrix tr td.urgency-label.name').eq(trIndex).remove();
                        $('#tablePriorityMatrix tr.priority-matrix-row').each(function () {
                            $(this).find('td.value').eq(trIndex).remove();
                        });

                        $('#tablePriorityMatrix td.ax-label.urgency-label').attr('colspan', $('#tablePriorityMatrix tr td.urgency-label.name').length);

                        //remove urgency value
                        tr.remove();

                        if ($('#tableBodyOfPriorityUrgencies tr.urgency-value').length == 0) {
                            $('#trPriorityUrgencyNoValues').show();
                        }

                        $(this).dialog("close");
                        PriorityUrgencyInputNamesRefresh();
                        PriorityMatrixModelRefresh();
                    }
                },
                {
                    text: Localization_No,
                    click: function () {
                        $(this).dialog("close");
                    }
                }
            ]
        });

        $("#dialog-confirm-priority-urgency-delete").dialog("open");
    }
}

function PriorityUrgencyInputNamesRefresh() {
    var index = 0;

    $('#tableBodyOfPriorityUrgencies tr.urgency-value').each(function () {
        var priorityUrgencyId = $(this).find('input[type="hidden"].priorityUrgencyId');
        var tbPriorityUrgencyName = $(this).find('div.editable input[type="hidden"].tbPriorityUrgencyName');
        var tbPriorityUrgencyDescription = $(this).find('div.editable input[type="hidden"].tbPriorityUrgencyDescription');

        priorityUrgencyId.attr('name', 'PriorityUrgencies[' + index + '].Id')
        tbPriorityUrgencyName.attr('name', 'PriorityUrgencies[' + index + '].Name')
        tbPriorityUrgencyDescription.attr('name', 'PriorityUrgencies[' + index + '].Description')

        index++;
    });
}

/* ---------------------- Priority Impacts functions --------------------------------------------------- */

function InitSortablePriorityImpactRows() {
    $("#tableBodyOfPriorityImpacts").sortable({
        handle: ".handle",
        axis: "y",
        update: function (event, ui) {
            PriorityImpactInputNamesRefresh();
        },
        start: function (event, ui) {
            ui.item.startPos = ui.item.index();
        },
        stop: function (event, ui) {
            //update to priority matrix
            //reorder impact rows
            PriorityMatrixMove(ui.item.startPos, ui.item.index(), "SwapPriorityImpactRows");
            PriorityMatrixModelRefresh();
        }
    });
}

function SwapPriorityImpactRows(i, j) {
    var rows = $('#tablePriorityMatrix tr.priority-matrix-row td.impact-label.name');
    var temp = rows.eq(i).html();
    rows.eq(i).html(rows.eq(j).html());
    rows.eq(j).html(temp);

    //switch urgency column values
    var source_tr = $('#tablePriorityMatrix tr.priority-matrix-row').eq(i);
    var target_tr = $('#tablePriorityMatrix tr.priority-matrix-row').eq(j);

    if (source_tr.find('td.value').length == target_tr.find('td.value').length) { //musi platit vzdy
        for (var i = 0; i < source_tr.find('td.value').length; i++) {
            source_tr.find('td.value').eq(i).swapWith(target_tr.find('td.value').eq(i));
        }
    }
}

function AddPriorityImpact() {
    $('#spanPriorityImpactNameRequired').hide();

    var priorityImpactName = $('#tbPriorityImpactName').val();
    var priorityImpactDescription = $('#tbPriorityImpactDescription').val();
    var error = false;

    if (priorityImpactName.trim() == '') {
        $('#spanPriorityImpactNameRequired').show();
        error = true;
    }

    if (!error) {
        $('#trPriorityImpactNoValues').hide();

        $('<tr class="impact-value">' +
            '<td><div class="handle"></div><input class="priorityImpactId" type="hidden"></td>' +
            '<td>' +
            '   <div class="readonly tbPriorityImpactName">' + htmlEncode(priorityImpactName) + '</div>' +
            '   <div class="editable hidden">' +
            '       <input type="text" class="required tbPriorityImpactName" value="' + htmlEncode(priorityImpactName) + '" />' +
            '       <input class="tbPriorityImpactName" value="' + htmlEncode(priorityImpactName) + '" type="hidden">' +
            '       <div class="valid-error hidden spanPriorityImpactNameRequired">Zadejte prosím název.</div>' +
            '   </div>' +
            '</td>' +
            '<td>' +
            '   <div class="readonly tbPriorityImpactDescription">' + htmlEncode(priorityImpactDescription) + '</div>' +
            '   <div class="editable hidden">' +
            '       <input type="text" class="tbPriorityImpactDescription" value="' + htmlEncode(priorityImpactDescription) + '" />' +
            '       <input class="tbPriorityImpactDescription" value="' + htmlEncode(priorityImpactDescription) + '" type="hidden">' +
            '   </div>' +
            '</td>' +
            '<td class="center nowrap">' +
            '   <div class="readonly">' +
            '       <div class="actions">' +
            '           <a href="javascript:void(0);" class="pi-row-edit">' + Localization_Edit + '</a>' +
            '           <a href="javascript:void(0);" class="pi-row-delete">' + Localization_Delete + '</a>' +
            '       </div>' +
            '   </div>' +
            '   <div class="editable hidden">' +
            '       <div class="actions">' +
            '           <a href="javascript:void(0);" class="button-blue small pi-row-save">' + Localization_Save + '</a>' +
            '           <a href="javascript:void(0);" class="pi-row-cancel-edit">' + Localization_Cancel + '</a>' +
            '       </div>' +
            '   </div>' +
            '</td> ' +
        '</tr>').prependTo($('#tableBodyOfPriorityImpacts'));

        $('#tbPriorityImpactName').val('');
        $('#tbPriorityImpactDescription').val('');

        PriorityImpactInputNamesRefresh();

        //update to priority matrix
        //var lastIndex = $('#tableBodyOfPriorityUrgencies tr.urgency-value').length - 1;
        var newTr = $('<tr></tr>').attr({ class: 'priority-matrix-row' });      
        $('<td></td>').attr({ class: 'impact-label name' }).text(priorityImpactName).appendTo(newTr);

        for (var i = 0; i < $('#tableBodyOfPriorityUrgencies tr.urgency-value').length ; i++) {
            CreateNewTdValueCell().appendTo(newTr);
        }

        var tdRowSpan = $('#tablePriorityMatrix td.ax-label.impact-label').detach();
        $('#tablePriorityMatrix tr').eq(1).after(newTr);
        tdRowSpan.attr('rowspan', $('#tablePriorityMatrix tr.priority-matrix-row').length);
        tdRowSpan.prependTo(newTr);

        PriorityMatrixModelRefresh();
    }
}

function EditPriorityImpact(tr) {
    $('#tableBodyOfPriorityImpacts tr.impact-value div.editable').hide();
    $('#tableBodyOfPriorityImpacts tr.impact-value div.readonly').show();

    tr.find('div.editable input[type="text"].tbPriorityImpactName').val(tr.find('div.editable input[type="hidden"].tbPriorityImpactName').val());
    tr.find('div.editable input[type="text"].tbPriorityImpactDescription').val(tr.find('div.editable input[type="hidden"].tbPriorityImpactDescription').val());

    tr.find('div.readonly').hide();
    tr.find('div.editable').show();
}

function CancelEditPriorityImpact(tr) {
    tr.find('div.editable').hide();
    tr.find('div.readonly').show();
}

function SavePriorityImpact(tr) {
    tr.find('div.editable .spanPriorityImpactNameRequired').hide();
    tr.find('div.editable .spanPriorityImpactColorError').hide();

    var priorityImpactName = tr.find('div.editable input[type="text"].tbPriorityImpactName').val();
    var priorityImpactDescription = tr.find('div.editable input[type="text"].tbPriorityImpactDescription').val();
    var error = false;

    if (priorityImpactName.trim() == '') {
        tr.find('div.editable .spanPriorityImpactNameRequired').show();
        error = true;
    }

    if (!error) {
        tr.find('div.editable input[type="hidden"].tbPriorityImpactName').val(priorityImpactName);
        tr.find('div.editable input[type="hidden"].tbPriorityImpactDescription').val(priorityImpactDescription);

        tr.find('div.readonly.tbPriorityImpactName').text(priorityImpactName);
        tr.find('div.readonly.tbPriorityImpactDescription').text(priorityImpactDescription);

        //update to priority matrix
        var trIndex = tr.prevAll().length;
        $('#tablePriorityMatrix td.impact-label.name').eq(trIndex).text(priorityImpactName);

        tr.find('div.editable').hide();
        tr.find('div.readonly').show();
    }
}

function DeletePriorityImpactConfirm(tr) {
    if ($('#tableBodyOfPriorityImpacts tr.impact-value').length == 1) {
        alert("Alespoň jedna položka musí zůstat.");
    }
    else {
        $("#dialog-confirm-priority-urgency-delete").dialog({
            buttons: [
                {
                    text: Localization_Yes,
                    click: function () {
                        //update to priority matrix
                        var trIndex = tr.prevAll().length;
                        var tdRowSpan = $('#tablePriorityMatrix td.ax-label.impact-label').detach();
                        $('#tablePriorityMatrix tr.priority-matrix-row').eq(trIndex).remove();
                        tdRowSpan.attr('rowspan', $('#tablePriorityMatrix tr.priority-matrix-row').length);
                        $('#tablePriorityMatrix tr.priority-matrix-row').eq(0).prepend(tdRowSpan);

                        //remove impact value
                        tr.remove();

                        if ($('#tableBodyOfPriorityImpacts tr.impact-value').length == 0) {
                            $('#trPriorityImpactNoValues').show();
                        }

                        $(this).dialog("close");
                        PriorityImpactInputNamesRefresh();
                        PriorityMatrixModelRefresh();
                    }
                },
                {
                    text: Localization_No,
                    click: function () {
                        $(this).dialog("close");
                    }
                }
            ]
        });

        $("#dialog-confirm-priority-urgency-delete").dialog("open");
    }
}

function PriorityImpactInputNamesRefresh() {
    var index = 0;

    $('#tableBodyOfPriorityImpacts tr.impact-value').each(function () {
        var priorityImpactId = $(this).find('input[type="hidden"].priorityImpactId');
        var tbPriorityImpactName = $(this).find('div.editable input[type="hidden"].tbPriorityImpactName');
        var tbPriorityImpactDescription = $(this).find('div.editable input[type="hidden"].tbPriorityImpactDescription');

        priorityImpactId.attr('name', 'PriorityImpacts[' + index + '].Id')
        tbPriorityImpactName.attr('name', 'PriorityImpacts[' + index + '].Name')
        tbPriorityImpactDescription.attr('name', 'PriorityImpacts[' + index + '].Description')

        index++;
    });
}


/* ---------------------- Priority Matrix functions ---------------------------------------------------- */

function PriorityMatrixModelRefresh() {

    var urgenciesCount = $('#tableBodyOfPriorityUrgencies tr.urgency-value').length;
    var impactsCount = $('#tableBodyOfPriorityImpacts tr.impact-value').length;
    
    for (var y = 0; y < impactsCount; y++) {
        for (var x = 0; x < urgenciesCount; x++) {
            var td = $('#tablePriorityMatrix tr.priority-matrix-row').eq(y).find('td.value').eq(x);
            var index = y * urgenciesCount + x;

            var hiddenPriorityUrgencyIndex = td.find('.hiddenPriorityUrgencyIndex');
            var hiddenPriorityImpactIndex = td.find('.hiddenPriorityImpactIndex');
            var hiddenPriorityValueIndex = td.find('.hiddenPriorityValueIndex');

            hiddenPriorityUrgencyIndex.val(x);
            hiddenPriorityImpactIndex.val(y);

            hiddenPriorityUrgencyIndex.attr('name', 'PriorityMatrix[' + index + '].UrgencyIndex');
            hiddenPriorityImpactIndex.attr('name', 'PriorityMatrix[' + index + '].ImpactIndex');
            hiddenPriorityValueIndex.attr('name', 'PriorityMatrix[' + index + '].PriorityValueIndex');
        }
    }
}

function ValidatePriorityMatrix() {
    $('#lbErrorComleteMatrix').hide();

    if ($('#rbPriorityMatrix').is(':checked') && $('#tablePriorityMatrix .hiddenPriorityValueIndex[value="-1"]').length > 0) {
        $('#lbErrorComleteMatrix').show();
        $('#tabs a[href="#tab-priority-matrix"]').tab('show')
        return false;
    }
    else
        return true;
}
