﻿$(document).ready(function () {
    /* --------------- Columns ----------------*/

    $("#aAddColumn").click(function () {
        $(this).addClass("loading-16");

        $.post(
        RQ_URL + '/Reports/Custom/AddColumn',
        {
        },
        function (data) {
            if (data == "SessionExpired")
                window.location = RQ_URL + "/Reports";
        },
        "json"
        )
        .fail(function (error) { alert(error.responseText); })
        .done(function () { ReloadTableOfColumns(); })
        .always(function () { $("#aAddColumn").removeClass("loading-16"); });
    });

    $("#tableOfColumns").on('click', '.deleteColumn', function () {
        $(this).parent("div.text-with-hiding-buttons").addClass("loading-16");

        $.post(
        RQ_URL + '/Reports/Custom/RemoveColumn',
        {
            index: $(this).closest("tr").data("column-index"),
        },
        function (data) {
            if (data == "SessionExpired")
                window.location = RQ_URL + "/Reports";
        },
        "json"
        )
        .fail(function (error) { alert(error.responseText); })
        .done(function () { ReloadTableOfColumns(); })
        .always(function () {  });
    });

    $("#tableOfColumns").on('change', 'select.dropDownColumn', function () {
        $.post(
        RQ_URL + '/Reports/Custom/ChangeColumnType',
        {
            index: $(this).closest("tr").data("column-index"),
            value: $(this).val(),
        },
        function (data) {
            if (data == "SessionExpired")
                window.location = RQ_URL + "/Reports";
        },
        "json"
        )
        .fail(function (error) { alert(error.responseText); })
        .done(function () { })
        .always(function () { FillSortByDropDownList(); });
    });

    $("#tableOfColumns").on('change', 'input.checkBoxCount', function () {
        $.post(
        RQ_URL + '/Reports/Custom/ChangeCheckBoxCount',
        {
            index: $(this).closest("tr").data("column-index"),
            value: $(this).is(':checked'),
        },
        function (data) {
            if (data == "SessionExpired")
                window.location = RQ_URL + "/Reports";
        },
        "json"
        )
        .fail(function (error) { alert(error.responseText); })
        .done(function () { })
        .always(function () { });
    });

    $("#tableOfColumns").on('change', 'input.checkBoxSum', function () {
        $.post(
        RQ_URL + '/Reports/Custom/ChangeCheckBoxSum',
        {
            index: $(this).closest("tr").data("column-index"),
            value: $(this).is(':checked'),
        },
        function (data) {
            if (data == "SessionExpired")
                window.location = RQ_URL + "/Reports";
        },
        "json"
        )
        .fail(function (error) { alert(error.responseText); })
        .done(function () { })
        .always(function () { });
    });

    $("#tableOfColumns").on('change', 'input.checkBoxAvg', function () {
        $.post(
        RQ_URL + '/Reports/Custom/ChangeCheckBoxAvg',
        {
            index: $(this).closest("tr").data("column-index"),
            value: $(this).is(':checked'),
        },
        function (data) {
            if (data == "SessionExpired")
                window.location = RQ_URL + "/Reports";
        },
        "json"
        )
        .fail(function (error) { alert(error.responseText); })
        .done(function () { })
        .always(function () { });
    });

    FillSortByDropDownList();
    //alert();
    if ($('#hiddenSortBy').val() != '')
        $('#ddlSortBy').val($('#hiddenSortBy').val()); //init when edit

    /* --------------- Conditions ----------------*/
    //AddColumn
    $("#tablesOfConditions").on('click', '#aAddConditionAnd', function () {
        /*$(this).addClass("loading-16");

        $.post(
        RQ_URL + '/Reports/AddConditionAnd',
        {
        },
        function (data) {
        },
        "json"
        )
        .fail(function (error) { alert(error.responseText); })
        .done(function () { ReloadTableOfConditions(); })
        .always(function () { $("#aAddConditionAnd").removeClass("loading-16"); });*/

        AddItem('Conjunction');
    });

    $("#tablesOfConditions").on('click', '#aAddConditionOr', function () {
        AddItem('Disjunction');
    });

    //O.H.
    InitSpinnersAndDatePickers();

    /* --------- Group By -------- */
    $("#main-content").on('change', '.reportType', function () {
        ReloadTableOfColumns();
    });

    /* --------------- Graph type ----------------*/
    SetVisibleForGraphType();
    SetVisibleForLineGraphType();
});

/* --------------- Graph type ----------------*/
function SetVisibleForGraphType() {
    var selectedReportType = $("input[name=ReportType]:radio:checked").val();
    if (selectedReportType == 1) {
        $("#graphTypes").hide();
    }
    else {
        $("#graphTypes").load(RQ_URL + "/Reports/Custom/PartialGraphType?Type=" + selectedReportType, function () { SetVisibleForLineGraphType(); });
        $("#graphTypes").show();
    }
}

function SetVisibleForLineGraphType()
{
    var selectedReportType = $("input[name=ReportType]:radio:checked").val();
    var selectedGraphType = $("input[name=GraphType]:radio:checked").val();

    if (selectedReportType == 3) {
        $("#graphLineType").show();
        $(".notTime").hide();
    }
    else {
        $("#graphLineType").hide();
        $(".notTime").show();
    }
}

/* --------------- Columns ----------------*/

function ReloadTableOfColumns() {
    var selectedReportType = $("input[name=ReportType]:radio:checked").val();
    $("#tableOfColumns").load(RQ_URL + "/Reports/Custom/PartialTableOfColumns?Type=" + selectedReportType, function () { FillSortByDropDownList(); });
    SetVisibleForGraphType();
}

function FillSortByDropDownList() {
    var wasSelected = $('#ddlSortBy').val();    
    
    var selectedReportType = $("input[name=ReportType]:radio:checked").val();
    if (selectedReportType == 3)
    {
        $(".notTime").hide();
    }
    else
    {
        $(".notTime").show();
    }

    $('#ddlSortBy').empty();

    $('#tableOfColumns option:selected').each(function () {
        if ($(this).val() != 20 && $(this).val() != 21 && $(this).val() != 27 && $(this).val() != 26 && $(this).val() != 19) {
            $('#ddlSortBy')
                .append($("<option></option>")
                .attr("value", $(this).val())
                .text($(this).text()));
        }
    });

    if (wasSelected !== null) {
        $('#ddlSortBy option[value="' + wasSelected + '"]').prop('selected', true);
    }
}

/* --------------- Conditions ----------------*/
/*
function ReloadTableOfConditions() {
    $("#tablesOfConditions").load(RQ_URL + "/Reports/PartialTableOfConditions");
}*/

/* from O.H.'s Views */
function AddItem(type) {

    var options = "";
    var options2 = "";

    $.ajax({
        url: RQ_URL + "/View/GetRuleFieldValues",
        context: document.body,
        async: false
    }).done(function (data) {
        var currentGroupKey;
        var groupOpened = false;

        $(data).each(function () {

            if (currentGroupKey != this.GroupKey) {
                currentGroupKey = this.GroupKey;

                if (groupOpened) {
                    options += "</optgroup>";
                }

                options += '<optgroup label="' + this.GroupName + '" value="' + this.GroupKey + '">';
                groupOpened = true;
            }

            var htmlattributes = "";
            $(this.HtmlAttributes).each(function () {
                htmlattributes += " " + this.Name + "='" + this.Value + "'";
            });

            options += "<option value='" + this.Value + "'" + htmlattributes + ">" + this.Text + "</option>";
        });

        if (groupOpened) {
            options += "</optgroup>";
        }
    });

    $.ajax({
        url: RQ_URL + "/View/GetRuleEnumeratorOrDataType?RuleId=1&report=true",
        context: document.body,
        async: false
    }).done(function (data) {
        $(data.Options).each(function () {
            options2 += "<option value='" + this.Value + "'>" + this.Text + "</option>";
        });
    });

    var pos = $("tr." + type + "-row").length;
    var row = '<tr class="' + type + '-row">' +
                '<td><select id="' + type + '_' + pos + '__FilterColumn" name="' + type + '[' + pos + '].FilterColumn" onchange="RuleFieldChanged(' + pos + ',\'' + type + '\')">' + options + '</select></td>' +
                '<td>' +
                    '<select id="' + type + '_' + pos + '__FilterOperator" name="' + type + '[' + pos + '].FilterOperator"><option value="1">' + Localization_Is + '</option><option value="2">' + Localization_IsNot + '</option></select> ' +
                    '<select id="' + type + '_' + pos + '__FilterStringValue" name="' + type + '[' + pos + '].FilterStringValue">' + options2 + '</select>' +
                '</td>' +
                '<td>' +
                    '<img class="hand" src="' + RQ_URL + '/Content/img/icon-cross.png" alt="' + Localization_Delete + '" title="' + Localization_Delete + '" onclick="javascript:RemoveRow(' + pos + ',\'' + type + '\')">' +
                    '<input id="' + type + '_' + pos + '__CustomFieldId" type="hidden" value="" name="' + type + '[' + pos + '].CustomFieldId" />' +
                    '<input id="' + type + '_' + pos + '__CustomFormFieldId" type="hidden" value="" name="' + type + '[' + pos + '].CustomFormFieldId" />' +
                    '<input id="' + type + '_' + pos + '__SlaId" type="hidden" value="" name="' + type + '[' + pos + '].SlaId" />' +
                    '<input id="' + type + '_' + pos + '__PriorityId" type="hidden" value="" name="' + type + '[' + pos + '].PriorityId" />' +
                    '<input id="' + type + '_' + pos + '__CategoryId" type="hidden" value="" name="' + type + '[' + pos + '].CategoryId" />' +
                '</td>' +
              '</tr>';

    $("tr.add-item-" + type).before(row);
}

function RuleFieldChanged(row, type) {

    var options = "";
    var ruleString = $("#" + type + "_" + row + "__FilterColumn").val();
    var id = -1;
    if (ruleString.indexOf(":") != -1) {
        id = ruleString.substr(0, ruleString.indexOf(":"));
    }
    else {
        id = ruleString;
    }
    var ruleId = id;
    var customFieldId = $("#" + type + "_" + row + "__FilterColumn option:selected").data('customfieldid');
    var customFormFieldId = $("#" + type + "_" + row + "__FilterColumn option:selected").data('customformfieldid');
    var slaId = $("#" + type + "_" + row + "__FilterColumn option:selected").data('slaid');
    var priorityId = $("#" + type + "_" + row + "__FilterColumn option:selected").data('priorityid');
    var categoryId = $("#" + type + "_" + row + "__FilterColumn option:selected").data('categoryid');

    $.ajax({
        url: RQ_URL + "/View/GetRuleOperatorValues?RuleId=" + ruleId + "&customFieldId=" + customFieldId + "&customFormFieldId=" + customFormFieldId + "&slaId=" + slaId,
        context: document.body,
        async: false
    }).done(function (data) {
        $("#" + type + "_" + row + "__FilterOperator option").remove();
        $(data).each(function () {
            options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
        });
        $("#" + type + "_" + row + "__FilterOperator").html(options);
        $("#" + type + "_" + row + "__CustomFieldId").val(customFieldId);
        $("#" + type + "_" + row + "__CustomFormFieldId").val(customFormFieldId);
        $("#" + type + "_" + row + "__SlaId").val(slaId);
        $("#" + type + "_" + row + "__PriorityId").val(priorityId);
        $("#" + type + "_" + row + "__CategoryId").val(categoryId);
    });


    options = "";

    $.ajax({
        url: RQ_URL + "/View/GetRuleEnumeratorOrDataType?RuleId=" + ruleId + "&categoryId=" + categoryId +"&customFieldId=" + customFieldId + "&customFormFieldId=" + customFormFieldId + "&slaId=" + slaId + "&priorityId=" + priorityId + "&report=true",
        context: document.body,
        async: false
    }).done(function (data) {

        $("#" + type + "_" + row + "__FilterStringValue").remove();
        var operator_ddl = $("#" + type + "_" + row + "__FilterOperator");

        if (data.Type == "spinner") {
            operator_ddl.after(' <input type="text" value="1" class="spinner" id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue" />');
            InitSpinnersAndDatePickers();
        }
        else if (data.Type == "textbox") {
            operator_ddl.after(' <input type="text" id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue" />');
            InitSpinnersAndDatePickers();
        }
        else if (data.Type == "date") {
            operator_ddl.after(' <input type="text" value="' + data.Value + '" class="datepicker" id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue" />');
            InitSpinnersAndDatePickers();
        }
        else if (data.Type == "time") {
            operator_ddl.after(' <input type="text" value="' + data.Value + '" class="time" id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue" />');
            InitSpinnersAndDatePickers();
        }
        else if (data.Type == "dropdown") {
            operator_ddl.after(' <select id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue"></select>');
            $(data.Options).each(function () {
                options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
            });
            $("#" + type + "_" + row + "__FilterStringValue").html(options);
        }
        else if (data.Type == "dropdown_client") {
            var dropdown = $('<select class="select2-for-views" style="min-width:200px;" multiple="multiple" id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue" ></select>');
            operator_ddl.after(dropdown);
            var initialize = true;
            dropdown.select2({
                minimumInputLength: 0,
                multiple: false,
                placeholder: Localization_Search,
                ajax: {
                    url: RQ_URL + '/Account/UsersForSelect2Ajax',
                    type: "POST",
                    dataType: 'json',
                    delay: 250,
                    data: function (params) {
                        return {
                            pageSize: 10,
                            pageNum: params.page || 1,
                            term: params.term,
                        };
                    },
                    processResults: function (data, params) {
                        params.page = data.PageNum;
                        data.Results.unshift(logged_user_select2_data_option);

                        return {
                            results: data.Results,
                            pagination: {
                                more: (data.PageNum * data.PageSize) < data.Total
                            }
                        };
                    },
                    cache: false,
                },
                escapeMarkup: function (markup) { return markup; },
                templateResult: formatUsersForSelect2AjaxData,
                templateSelection: formatUsersForSelect2AjaxElement,
            });
        }
        else if (data.Type == "dropdowntree") {
            var dropdown = $('<select id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue"></select>');
            operator_ddl.after(dropdown);
            var optgroup = null;

            $(data.Tree).each(function () {
                if (this.IsDepartment) {
                    optgroup = $(document.createElement('optgroup'))
                    .attr('label', htmlDecode(Array(this.Depth + 1).join("&nbsp;&nbsp;&nbsp;&nbsp;")) + this.Name)
                    .appendTo(dropdown);
                }
                else {
                    var option = $(document.createElement('option'))
                    .attr('value', this.Id)
                    .attr('title', this.Description)
                    .html(Array(this.Depth).join("&nbsp;&nbsp;&nbsp;&nbsp;") + htmlEncode(this.Name));

                    option.appendTo(optgroup !== null ? optgroup : dropdown);
                }
            });
        }
    });
}

function RemoveRow(row, type) {

    $("tr." + type + "-row:eq(" + row + ")").remove();
    ReIndex(type);
}

function ReIndex(type) {

    $("tr." + type + "-row").each(function (index) {

        $("img", this).attr("onclick", "javascript:RemoveRow(" + index + ",'" + type + "')");

        $("select, input", this).each(function () {

            var select = $(this);
            var id = select.attr("id");
            var pos = id.lastIndexOf("_");
            if (pos != -1) {
                id = id.substring(pos + 1);
                select.attr("id", "" + type + "_" + index + "__" + id);
                select.attr("name", "" + type + "[" + index + "]." + id);

                if (select.attr("onchange"))
                    select.attr("onchange", "RuleFieldChanged(" + index + ",'" + type + "')");
            }
            else
                alert("Reindex failed");
        });
    });
}

function InitSpinnersAndDatePickers() {
    $('.spinner').spinner({ min: 1, max: 999 });
    $(".datepicker").datepicker();

    if ($(".time").lenght > 0) {
        $(".time").rules("ourTime");
    }
}

/* ------------------------ Group By ---------------------------------- */