﻿$(document).ready(function () {

    if (!$("#IsForOperatorGroup").is(":checked"))
        $("#SelectedGroup").prop("disabled", true);

    if ($("#SelectedGroup option").length == 0) {
        $("#IsForOperatorGroup").prop("disabled", true);
    }

    InitSpinnersAndDatePickers();
});

function AvailableForChanged(rb) {

    $("#IsForAllOperators").removeAttr("checked");
    $("#IsForOperatorGroup").removeAttr("checked");
    $("#IsPersonal").removeAttr("checked");

    $(rb).prop("checked", "checked");

    if ($(rb).attr("id") != "IsForOperatorGroup")
        $("#SelectedGroup").prop("disabled", "disabled");
    else
        $("#SelectedGroup").removeAttr("disabled");
}

function AddItem(type) {
    
    var options = "";
    var options2 = "";
    
    $.ajax({
        url: RQ_URL + "/View/GetRuleFieldValues",
        context: document.body,
        async: false
    }).done(function (data) {
        var currentGroupKey;
        var groupOpened = false;

        $(data).each(function () {

            if (currentGroupKey != this.GroupKey) {
                currentGroupKey = this.GroupKey;

                if (groupOpened) {
                    options += "</optgroup>";
                }

                options += '<optgroup label="' + this.GroupName + '" value="' + this.GroupKey + '">';
                groupOpened = true;
            }
            
            var htmlattributes = "";
            $(this.HtmlAttributes).each(function () {
                htmlattributes += " " + this.Name + "='" + this.Value + "'";
            });

            options += "<option value='" + this.Value + "'" + htmlattributes + ">" + this.Text + "</option>";
        });

        if (groupOpened) {
            options += "</optgroup>";
        }
    });

    $.ajax({
        url: RQ_URL + "/View/GetRuleEnumeratorOrDataType?RuleId=1",
        context: document.body,
        async: false
    }).done(function (data) {
        $(data.options).each(function () {
            options2 += "<option value='" + this.Value + "'>" + this.Text + "</option>";
        });
    });

    var pos = $("tr." + type + "-row").length;
    var row = '<tr class="' + type + '-row">' +
                '<td><select id="' + type + '_' + pos + '__FilterColumn" name="' + type + '[' + pos + '].FilterColumn" onchange="RuleFieldChanged(' + pos + ',\''+type+'\')">' + options + '</select></td>' +
                '<td>' +
                    '<select id="' + type + '_' + pos + '__FilterOperator" name="' + type + '[' + pos + '].FilterOperator"><option value="1">' + Localization_Is + '</option><option value="2">' + Localization_IsNot + '</option></select> ' +
                    '<select id="' + type + '_' + pos + '__FilterStringValue" name="' + type + '[' + pos + '].FilterStringValue">' + options2 + '</select>' +
                '</td>' +
                '<td>' +
                    '<img class="hand" src="' + RQ_URL + '/Content/img/icon-cross.png" alt="' + Localization_Delete + '" title="' + Localization_Delete + '" onclick="javascript:RemoveRow(' + pos + ',\'' + type + '\')">' +
                    '<input id="' + type + '_' + pos + '__CustomFieldId" type="hidden" value="" name="' + type + '[' + pos + '].CustomFieldId" />' +
                    '<input id="' + type + '_' + pos + '__CustomFormFieldId" type="hidden" value="" name="' + type + '[' + pos + '].CustomFormFieldId" />' +
                    '<input id="' + type + '_' + pos + '__SlaId" type="hidden" value="" name="' + type + '[' + pos + '].SlaId" />' +
                    '<input id="' + type + '_' + pos + '__PriorityId" type="hidden" value="" name="' + type + '[' + pos + '].PriorityId" />' +
                '</td>' +
              '</tr>';

    $("tr.add-item-" + type).before(row);
}

function RuleFieldChanged(row, type) {

    var options = "";
    var ruleId = $("#" + type + "_" + row + "__FilterColumn").val();
    var customFieldId = $("#" + type + "_" + row + "__FilterColumn option:selected").data('customfieldid');
    var customFormFieldId = $("#" + type + "_" + row + "__FilterColumn option:selected").data('customformfieldid');
    var slaId = $("#" + type + "_" + row + "__FilterColumn option:selected").data('slaid');
    var priorityId = $("#" + type + "_" + row + "__FilterColumn option:selected").data('priorityid');

    $.ajax({
        url: RQ_URL + "/View/GetRuleOperatorValues?RuleId=" + ruleId + "&customFieldId=" + customFieldId + "&customFormFieldId=" + customFormFieldId,
        context: document.body,
        async: false
    }).done(function (data) {
        $("#" + type + "_" + row + "__FilterOperator option").remove();
        $(data).each(function () {
            options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
        });
        $("#" + type + "_" + row + "__FilterOperator").html(options);
        $("#" + type + "_" + row + "__CustomFieldId").val(customFieldId);
        $("#" + type + "_" + row + "__CustomFormFieldId").val(customFormFieldId);
        $("#" + type + "_" + row + "__SlaId").val(slaId);
        $("#" + type + "_" + row + "__PriorityId").val(priorityId);
    });

    
    
    options = "";

    $.ajax({
        url: RQ_URL + "/View/GetRuleEnumeratorOrDataType?RuleId=" + ruleId + "&customFieldId=" + customFieldId + "&customFormFieldId=" + customFormFieldId + "&slaId=" + slaId + "&priorityId=" + priorityId,
        context: document.body,
        async: false
    }).done(function (data) {

        $("#" + type + "_" + row + "__FilterStringValue").remove();
        var operator_ddl = $("#" + type + "_" + row + "__FilterOperator");

        if (data.type == "spinner") {
            operator_ddl.after(' <input type="text" value="1" class="spinner" id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue" />');
            InitSpinnersAndDatePickers();
        }
        else if (data.type == "textbox") {
            operator_ddl.after(' <input type="text" id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue" />');
            InitSpinnersAndDatePickers();
        }
        else if (data.type == "date") {
            operator_ddl.after(' <input type="text" value="' + data.value + '" class="datepicker" id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue" />');
            InitSpinnersAndDatePickers();
        }
        else if (data.type == "time") {
            operator_ddl.after(' <input type="text" value="' + data.value + '" class="time" id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue" />');
            InitSpinnersAndDatePickers();
        }
        else if (data.type == "dropdown") {
            operator_ddl.after(' <select id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue"></select>');
            $(data.options).each(function () {
                options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
            });
            $("#" + type + "_" + row + "__FilterStringValue").html(options);
        }
    });
}

function RemoveRow(row, type) {
    
    $("tr." + type + "-row:eq(" + row + ")").remove();
    ReIndex(type);
}

function ReIndex(type) {

    $("tr." + type + "-row").each(function (index) {

        $("img", this).attr("onclick", "javascript:RemoveRow(" + index + ",'" + type + "')");
        
        $("select, input", this).each(function () {

            var select = $(this);
            var id = select.attr("id");
            var pos = id.lastIndexOf("_");
            if (pos != -1) {
                id = id.substring(pos + 1);
                select.attr("id", "" + type + "_" + index + "__" + id);
                select.attr("name", "" + type + "[" + index + "]." + id);

                if (select.attr("onchange"))
                    select.attr("onchange", "RuleFieldChanged(" + index + ",'" + type + "')");
            }
            else
                alert("Reindex failed");
        });
    });
}

function InitSpinnersAndDatePickers() {
    $('.spinner').spinner({ min: 1, max: 999 });
    $(".datepicker").datepicker();

    if ($(".time").lenght > 0) {
        $(".time").rules("ourTime");
    }
}

